// -*- mode: c++; c-file-style: "linux"; c-basic-offset: 2; indent-tabs-mode: nil -*-
//
//  Copyright (C) 2020      Kuba Ober <kuba@bertec.com>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
//
//  SPDX-License-Identifier: GPL-2.0+

#include "CellPtr.h"
#include "GroupCell.h"

const Observed::ControlBlock Observed::ControlBlock::empty{nullptr};

size_t Observed::m_instanceCount;
size_t CellPtrBase::m_instanceCount;

// This is a specialization of this method. It's useful when GroupCell
// is not a fully defined class, but someone wants to use the methods of
// CellPtr<GroupCell>.
template <>
CellPtr<GroupCell>::pointer CellPtr<GroupCell>::get() const
{ return static_cast<pointer>(base_get()); }
